/* 
 * File:     Terrain.h
 * Author:   PAE
 * Date:     18.03.2006
 * Modified: 23.03.2006
 *
 * Purpose: Headerdatei zur Klasse Terrain
 */

#ifndef PAE_TERRAIN_HEADER
#define PAE_TERRAIN_HEADER

#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

using namespace std;



class Terrain{
  private:
    float ***data;//hoehen und pflanzendaten zu dem feld
    float ***normals;//die normalen der punkte werden hier gespeichert
    int width;//breite
    int height;//hoehe

    float scal_x;
    float scal_y;

    float shift_x;
    float shift_y;

    bool water;//soll das wasser gezeichnet werden
    void DrawWater(void);//es wird eine wasserflche gezeichnet auf WASSERHOEHE

	void TransformWorldTerrain(float wx, float wy, float *tx, float *ty);
	void TransformTerrainWorld(float tx, float ty, float *wx, float *wy);

  public:
    Terrain();//konstruktor fuer terrain mittels zerteilunkssynthese, terrain ist 100*100 gross
    float GetFood(float x, float y);//wie viel essen ist an einer stelle 
    void ReduceFood(float x, float y, float amount);//das essen an einer stelle wird reduziert um amount
    float GetHeight(float x, float y);//wie hoch ist das terrain an stelle x|y
    void GrowFood(void);//die pflanzen wachsen nach
    void Draw(void);//das terrain wird gezeichnet
    void SwitchWater(void);//das wasser wird an/bzw ausgeschaltet
    void AddHeight(float amount);//das komplette terrain wird um amount erhoeht
    void ReBuildNormals(void);//die normalen werden neu berechnet, falls das terrain sich aendern sollte
    int GetWidth(void);//wie breit ist das terrain
    int GetHeight(void);//wie tief ist das terrain
    void ScaleTerrain(float min, float max);//das terrain wird neu scaliert
    void SoftenTerrain(void);//das terrain wird geglaettet
};

class PaeClock{
  private:
    int minutes;//die kleinste zeiteinheit
    int hours;//jede stunde hat 60 min
    int days;//jeder tag hat 24 stunden
    int months;//jeder monat hat 30 tage
    int years;//jedes jahr hat 12 monate
  public:
    PaeClock(void);//die uhr beginnt um 0h0 DDMMYY : 010100
    void Tick(void);//die uhr geht um eine minute weiter
    int WhichTime(int what);//eine variable wird zurueckgegeben
    void PrintTime(void);//die zeit wird in der console ausgegeben
    void Set(int what, int amount);
};

float PaeRand(float lower, float upper);

#endif // PAE_TERRAIN_HEADER

