/* 
 * File:     Wolf.cpp
 * Author:   PAE
 * Date:     27.03.2006
 * 
 *
 * Purpose: Headerdatei zur Klasse Wolf
 */



#ifndef WOLF_HEADER
#define WOLF_HEADER


#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

#include "Definitions.h"
#include "Utilities.h"
#include "World.h"
#include "Animal.h"
#include "Info.h"

using namespace std;


class World;


class Wolf: public Animal{
  private:
    float up[3];//oben
    float acc[3];//beschleunigung nur 2d berechnung
	float angle; // Orientierungswinkel im Bereich [0-360]
	
    float v;
    int state;             // 
    int schlafzeit;        // wie lange der wolf noch ruht
	float jagd_instinkt;   // je hoeher, desto besser jagt der wolf

    float hunger;          // 0 = satt, 1 = sehr hungrig
    int maxausdauer;       // wie viele runden kann der wolf maximal rennen
    int ausdauer;          // wie viele runden kann der wolf noch rennen

  public:
    
    Wolf *nextwolf;
 
	// Konstruktoren
    Wolf(World *w);
    Wolf(float x, float y, World *w);

	// Explizite Modifizierer

    void SetParameters(void);

	// Implizite Modifizierer
    void Think(void);
    void Move(void);
    void Act(void);

    void Draw(int visual);
};


 
#endif  // WOLF_HEADER
