/* 
 * File:     World.cpp
 * Author:   NMM
 * Date:     12.03.2006
 * Modified: 27.03.2006
 *
 * Purpose: Definitionen der Klasse World
 */
 
#include "World.h"
#include "Utilities.h"
#include "Definitions.h"
#include "Info.h"

//Funktionen der Klasse Simulation

World::World(){
  /*
   * Construct the terrain
   */
  terr = new Terrain();                       
  terr->SoftenTerrain();
  terr->ReBuildNormals();


  /* 
   * Add sheep to the sheep list
   */
   
  firstsheep = NULL;
  CreateSheep(STARTING_SHEEP);
  number_of_sheep = STARTING_SHEEP;
  
  if (STARTING_SHEEP > MAX_SHEEP){
    cout << "Fehler in Parametern: in World::World ist " << endl;
    cout << "STARTING_SHEEP > MAX_SHEEP" << endl;
    system("Pause");
    exit(0);
  }
  /* 
   * Add wolf to the wolf list
   */
   
  firstwolf = NULL;
  CreateWolf(STARTING_WOLF);
  
  
  /*
   * Noch kein Kadaver
   */
  
  firstcadavre = NULL;
  number_of_cadavre = 0;
 
  /*
   * One experimental Stone
   */
  stone = new Stone();
  stone->SetPosition(20.0,30.0,2.0);

  cout << "World created!" << endl;

}


void World::CreateSheep(){

  CreateSheep(1);

}

void World::CreateSheep(int n){

    PaeSheep *new_sheep;
    PaeSheep *last_sheep;
    float x;
    float y;

	/*
	 * Keine Schafe => Bye-bye
	 */

	if(n <= 0 ){
	  return;
	}


	/*
	 * We look for the last sheep in the list
	 */
	last_sheep = NULL;
    new_sheep = firstsheep;
    while(new_sheep != NULL){
      last_sheep = new_sheep;
	  new_sheep = new_sheep->nextsheep;
    }


	/*
	 * last_sheep is now NULL or pointing to the last sheep
	 */
	if(last_sheep == NULL){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  firstsheep = new PaeSheep(x,y,this);
	  last_sheep = firstsheep;
	  n--;
	}


	/*
	 * last_sheep is pointing to the last sheep
	 */

	for(int i=0;i<n;i++){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  last_sheep->nextsheep = new PaeSheep(x,y,this);
	  last_sheep = last_sheep->nextsheep;
	}
}



void World::CreateWolf(){

  CreateWolf(1);

}

void World::CreateWolf(int n){

    Wolf *new_wolf;
    Wolf *last_wolf;
    float x;
    float y;

	/*
	 * Keine Woelfe => Bye-bye
	 */

	if(n <= 0 ){
	  return;
	}


	/*
	 * We look for the last wolf in the list
	 */
	last_wolf = NULL;
    new_wolf = firstwolf;
    while(new_wolf != NULL){
      last_wolf = new_wolf;
	  new_wolf = new_wolf->nextwolf;
    }


	/*
	 * last_wolf is now NULL or pointing to the last wolf
	 */
	if(last_wolf == NULL){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  firstwolf = new Wolf(x,y,this);
	  last_wolf = firstwolf;
	  n--;
	}


	/*
	 * last_wolf is pointing to the last wolf
	 */

	for(int i=0;i<n;i++){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  last_wolf->nextwolf = new Wolf(x,y,this);
	  last_wolf = last_wolf->nextwolf;
	}
}





void World::Draw(int visual){
  PaeSheep *this_sheep;
  Wolf *this_wolf;
  PaeCadavre *this_cadavre;
  int i;
  i=0;


  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    stone->Draw();
  glPopMatrix();

  this_sheep = firstsheep;
  while(this_sheep != NULL){       //sage jedem Schaf, dass es sich zeichnen soll
    i++;
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
      this_sheep->Draw(visual);
    glPopMatrix();
    this_sheep = this_sheep->nextsheep;
	
  }
  this_wolf = firstwolf;
  while(this_wolf != NULL){
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
      this_wolf->Draw(visual);
    glPopMatrix();
    this_wolf = this_wolf->nextwolf;
  }
  
  this_cadavre = firstcadavre;
  while(this_cadavre != NULL){
    this_cadavre->Draw();
    this_cadavre = this_cadavre->next_cadavre;
  }
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    terr->Draw();
    glTranslatef(50.0,50.0,0);
    glColor3f(0.0,0.0,1.0);
    glutSolidSphere(100.0,100,100);
  glPopMatrix();

  glPushMatrix();
    for(i=0;i<4;i++){
      glTranslatef(0.0,0.0,1.0);
      this->DrawFences();
    }
  glPopMatrix();
}



void World::DrawFences(void){

  static GLfloat fence_color[3] = {0.8,0.6,0.5};
  static float bar_width  = 0.2;
  static float bar_height = 0.2;
  
  glPushMatrix();
    glTranslatef(102.0,51.0,0.0);
    glScalef(bar_width,102.0,bar_height);
    glColor3fv(fence_color);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();
    glTranslatef(51.0,102.0,0.0);
    glScalef(102.0,bar_width,bar_height);
    glColor3fv(fence_color);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();
    glTranslatef(51.0,0.0,0.0);
    glScalef(102.0,bar_width,bar_height);
    glColor3fv(fence_color);
    glutSolidCube(1.0);
  glPopMatrix();

  glPushMatrix();
    glTranslatef(0.0,51.0,0.0);
    glScalef(bar_width,102.0,bar_height);
    glColor3fv(fence_color);
    glutSolidCube(1.0);
  glPopMatrix();
}





void World::Prepare(){
     PaeSheep *this_sheep;
     Wolf *this_wolf;
     PaeCadavre *this_cadavre;
     this_sheep = firstsheep;
     while(this_sheep != NULL){
       this_sheep->Think();
       this_sheep = this_sheep->nextsheep;
     }  
     this_wolf = firstwolf;
     while(this_wolf != NULL){
       this_wolf->Think();
       this_wolf = this_wolf->nextwolf;
     }
     this_cadavre = firstcadavre;
     while(this_cadavre != NULL){
       this_cadavre->Rot();
       this_cadavre = this_cadavre->next_cadavre;
     }
        
}

void World::Action(){
  float cur_pos[3];
  int invert_flag;
  float flesh;
  PaeSheep *this_sheep;
  Wolf *this_wolf;
  PaeCadavre *this_cadavre, *last_cadavre;

  /*
   * Das Gras waechst ueberall
   */
  terr->GrowFood();

  /* 
   * Alle Schafe bewegen sich
   */

  this_sheep = firstsheep;
  while(this_sheep != NULL){
    this_sheep->Move();
	
	/*
	 * If sheep leaves terrain, turn it around!
	 */
	invert_flag = false;
	this_sheep->GetPosition(cur_pos);
	if (cur_pos[0] < 0.0){
	  cur_pos[0] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[0] >= 99.0){
	  cur_pos[0] = 98.9;
	  invert_flag = true;
	}
	if (cur_pos[1] < 0.0){
	  cur_pos[1] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[1] >= 99.0){
	  cur_pos[1] = 98.9;
	  invert_flag = true;
	}
	if(invert_flag){
	  this_sheep->InvertDirection();
	}

	/*
	 * Put sheep to the right height
	 */
	cur_pos[2] = terr->GetHeight(cur_pos[0],cur_pos[1]);
	this_sheep->SetPosition(cur_pos[0],cur_pos[1],cur_pos[2]);
	
	/*
	 * next, please!
	 */
    this_sheep = this_sheep->nextsheep;
  }         


  /* 
   * Alle Woelfe bewegen sich
   */

  this_wolf = firstwolf;
  while(this_wolf != NULL){
    this_wolf->Move();
	
	/*
	 * If sheep leaves terrain, turn it around!
	 */
	invert_flag = false;
	this_wolf->GetPosition(cur_pos);
	if (cur_pos[0] < 0.0){
	  cur_pos[0] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[0] >= 99.0){
	  cur_pos[0] = 98.9;
	  invert_flag = true;
	}
	if (cur_pos[1] < 0.0){
	  cur_pos[1] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[1] >= 99.0){
	  cur_pos[1] = 98.9;
	  invert_flag = true;
	}
	if(invert_flag){
	  this_wolf->InvertDirection();
	}

	/*
	 * Put wolf to the right height
	 */
	cur_pos[2] = terr->GetHeight(cur_pos[0],cur_pos[1]);
	this_wolf->SetPosition(cur_pos[0],cur_pos[1],cur_pos[2]);
	
	/*
	 * next, please!
	 */
    this_wolf = this_wolf->nextwolf;
  }         


  /*
   * Alle Tiere duerfen was tun (im Moment nur die Woelfe)
   */
  this_wolf = firstwolf;
  while(this_wolf != NULL){
       this_wolf->Act();
       this_wolf = this_wolf->nextwolf;
  } 


  /*
   * Die "leeren" cadaver werden entfernt
   */
  this_cadavre = firstcadavre;
  last_cadavre = NULL;
  while(this_cadavre != NULL){
    flesh = this_cadavre->GetFlesh();
    if(flesh <= 0.1){
      //erster kadaver?
	  number_of_cadavre--;
      if(this_cadavre == firstcadavre){
        firstcadavre = firstcadavre->next_cadavre;
        delete this_cadavre;
        this_cadavre = firstcadavre;
        continue;
      }else{
        last_cadavre->next_cadavre = this_cadavre->next_cadavre;
        delete this_cadavre;
        this_cadavre = last_cadavre->next_cadavre;
        continue;
      }
    }
    last_cadavre = this_cadavre;
    this_cadavre = this_cadavre->next_cadavre;
  }
}

float World::GetHeight(float x, float y){
      return terr->GetHeight(x,y);
}




Stone * World::GetNearestStone(Animal* asking_sheep){
  return stone;
}



PaeSheep * World::GetNearestSheep(Animal* asking_animal){
  PaeSheep *this_sheep;
  PaeSheep *nearest_sheep;
  float min_distance,distance;
  
  if(firstsheep == NULL){
	return(NULL);
  }

  this_sheep = firstsheep;
  nearest_sheep = firstsheep;
  
  min_distance = Distance(this_sheep,asking_animal);
  while(this_sheep->nextsheep != NULL){
    this_sheep = this_sheep->nextsheep; 
    if(this_sheep == asking_animal){
      continue;
    }

    distance = Distance(this_sheep,asking_animal);
    if(distance < min_distance){
      min_distance = distance;
      nearest_sheep = this_sheep;
    }
  }
  return(nearest_sheep);    
}



Wolf * World::GetNearestWolf(Animal* asking_animal){
  Wolf *this_wolf;
  Wolf *nearest_wolf;
  float min_distance,distance;
  
  this_wolf = firstwolf;
  nearest_wolf = firstwolf;
  
  
  min_distance = Distance(this_wolf,asking_animal);
  while(this_wolf->nextwolf != NULL){
    this_wolf = this_wolf->nextwolf; 
    if(this_wolf == asking_animal){
      continue;
    }

    distance = Distance(this_wolf,asking_animal);
    if(distance < min_distance){
      min_distance = distance;
      nearest_wolf = this_wolf;
    }
  }
  return(nearest_wolf);    
}


PaeCadavre *World::GetNearestCadavre(Animal *asking_animal){
  PaeCadavre *this_cadavre;
  PaeCadavre *nearest_cadavre;
  float min_distance,distance;
  
  this_cadavre = firstcadavre;
  nearest_cadavre = firstcadavre;
  
  if(this_cadavre == NULL){
    return NULL;
  }
  
  min_distance = Distance(this_cadavre,asking_animal);
  while(this_cadavre->next_cadavre != NULL){
    this_cadavre = this_cadavre->next_cadavre;

    distance = Distance(this_cadavre,asking_animal);
    if(distance < min_distance){
      min_distance = distance;
      nearest_cadavre = this_cadavre;
    }
  }
  return(nearest_cadavre);  
}




PaeSheep **World::GetFiveNearestSheep(Animal* asking_animal){
   float  dist[5] = {10000.0,10000.0,10000.0,10000,10000.0};
   PaeSheep **near_sheep;
   PaeSheep *this_sheep;
   
   int i,j;
   float d;
   
   near_sheep = new PaeSheep*[5];
   near_sheep[0] = NULL; 
   near_sheep[1] = NULL; 
   near_sheep[2] = NULL; 
   near_sheep[3] = NULL; 
   near_sheep[4] = NULL;
   
   this_sheep = firstsheep;
   
   while(this_sheep != NULL){
     if(this_sheep == asking_animal){
       this_sheep = this_sheep->nextsheep;
       continue;
     }
     d = Distance(this_sheep,asking_animal);
     for(i=0;i<5;i++){
       if(d < dist[i]){
         /*
          * Verschiebe nachfolgende Schafe nach hinten
          */
         for(j=4;j>i;j--){
           near_sheep[j] = near_sheep[j-1];
           dist[j] = dist[j-1];
         }   
         near_sheep[i] = this_sheep;
         dist[i] = d;
         break;
         }
     }
     this_sheep = this_sheep->nextsheep;
   }
   
   return(near_sheep);
}


float World::GetGras(float x, float y){
   return(terr->GetFood(x,y));
}

void World::EatGras(float x, float y){
  terr->ReduceFood(x,y,FOOD_PER_SHEEP);
}


//toetet ein schaf an ungefaher der angegebenen position
bool World::KillSheep(float *p){
  PaeSheep *this_sheep, *last_sheep;
  float pos[3], dist;
  float dx,dy,dz;

  if(firstsheep == NULL){
	cout << "Error: Hier kann man kein Schaf toeten: keine Schafe da!" << endl;
    return false;
  }

  last_sheep = firstsheep;
  this_sheep = firstsheep;
  do{
	this_sheep->GetPosition(pos);
	dx = p[0] - pos[0];
	dy = p[0] - pos[0];
	dz = p[0] - pos[0];
	dist = dx*dx+dy*dy+dz*dz;

	if(dist < JAGDABSTAND){
	  if (this_sheep == firstsheep){
		firstsheep = this_sheep->nextsheep;
	  } else {
		last_sheep->nextsheep = this_sheep->nextsheep;
	  }		
	  delete(this_sheep);
	  CreateCadavre(p);
	  number_of_sheep--;
	  return true;	   
	}
	last_sheep = this_sheep;
	this_sheep = this_sheep->nextsheep;
  } while (this_sheep != NULL);
  
  return false;
}


void World::CreateCadavre(float *p){
  PaeCadavre *this_cadavre, *last_cadavre;

  number_of_cadavre++;

  if(firstcadavre == NULL){
	this_cadavre = new PaeCadavre(this, p);
	firstcadavre = this_cadavre;
	return;
  }
  
  this_cadavre = firstcadavre;
  last_cadavre = NULL;
  while(this_cadavre != NULL){
	last_cadavre = this_cadavre;
    this_cadavre = this_cadavre->next_cadavre; 
  }
  this_cadavre = new PaeCadavre(this, p);
  last_cadavre->next_cadavre = this_cadavre;
}



bool World::EatFlesh(float *p, float amount){
  PaeCadavre *this_cadavre;
  float flesh;
  float cad_pos[3], dist;
  float dx,dy,dz;

  this_cadavre = firstcadavre;
  while(this_cadavre != NULL){
    flesh = this_cadavre->GetFlesh();
    this_cadavre->GetPosition(cad_pos);
	dx = p[0]-cad_pos[0];
	dy = p[1]-cad_pos[1];
	dz = p[2]-cad_pos[2];
    dist = dx*dx+dy*dy+dz*dz;

	/* Kadaver zum fressen gefunden! */
    if(dist < JAGDABSTAND && flesh > amount){
      this_cadavre->ReduceFlesh(amount);
      return true;
    }
	this_cadavre = this_cadavre->next_cadavre;
  }
  
  /* Kein Kadaver da! */
  return false;
}

Info* World::GetInfo(PaeSheep *me){
      int sheepcount;
      float dist[2];
      float pos_of_me[3];
      float pos2[3];
      float dir_of_me[3];
      Info *I;
      PaeSheep *this_sheep = firstsheep;
      
      me->GetPosition(pos_of_me);
      me->GetDirection(dir_of_me);
      I = new Info();
	  
	  sheepcount = 0;
	  while (this_sheep != NULL) {
        if(this_sheep == me){
          this_sheep = this_sheep->nextsheep;
          continue;
        }

        this_sheep->GetPosition(pos2);
        dist[0] = pos_of_me[0] - pos2[0];
        dist[1] = pos_of_me[1] - pos2[1];      
        if(Skalarprodukt(dir_of_me[0],dir_of_me[1],dist[0],dist[1]) > BLICKWINKELCOS){
          I->SP[sheepcount] = this_sheep;
          sheepcount++;
        }
      this_sheep = this_sheep -> nextsheep;
      }while(this_sheep != NULL);
      
      I->sheep = sheepcount;
       return I; 
}

int World::GetNumberOfSheep(void){
  return(number_of_sheep);
}

int World::GetNumberOfCadavre(void){
  return(number_of_cadavre);
}
